#ifndef __TABAPP_H
#define __TABAPP_H

#ifndef __RELAPP_H
#include <relapp.h>
#endif

#define GR_SEARCH 29
#define GR_MODIFY_PROTECTED 30
#define GR_RECORD_PROTECTED 31

#define FPC "FPC"

class Tab_application : public TRelation_application
{    
  TMask*     _msk;
  TRelation* _rel;
  TString16  _tabname;

protected:
  virtual bool protected_record(TRectype& rec);
  virtual TMask* get_mask(int mode = NO_MODE) { return _msk;}
  virtual bool changing_mask(int mode) { return FALSE;}
  virtual TRelation* get_relation() const { return _rel;}
  virtual void  init_query_mode(TMask& m);
  virtual void  init_modify_mode(TMask& m);
  virtual bool user_create() ;                         
  virtual bool user_destroy() ;                        
  virtual void print();

public:
  Tab_application() : _msk(NULL), _rel(NULL) {}
  virtual ~Tab_application() {}
  const TString& get_tabname() const { return _tabname; }
};

#endif

